org.springframework.cache.annotation

## Class CachingConfigurerSupport

- java.lang.Object
- - org.springframework.cache.annotation.CachingConfigurerSupport

- All Implemented Interfaces:
    CachingConfigurer
  Direct Known Subclasses:
    JCacheConfigurerSupport

      public class CachingConfigurerSupport
      extends Object
      implements CachingConfigurer

  An implementation of `CachingConfigurer` with empty methods allowing subclasses to override only the methods they're interested in.
  Since:
    4.1
  Author:
    Stephane Nicoll
  See Also:
    `CachingConfigurer`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `CachingConfigurerSupport()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `CacheManager` | `cacheManager()` Return the cache manager bean to use for annotation-driven cache management.
    `CacheResolver` | `cacheResolver()` Return the `CacheResolver` bean to use to resolve regular caches for annotation-driven cache management.
    `CacheErrorHandler` | `errorHandler()` Return the `CacheErrorHandler` to use to handle cache-related errors.
    `KeyGenerator` | `keyGenerator()` Return the key generator bean to use for annotation-driven cache management.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CachingConfigurerSupport

          public CachingConfigurerSupport()

  - ### Method Detail

    - #### cacheManager

          @Nullable
          public CacheManager cacheManager()

      Description copied from interface: `CachingConfigurer`
      Return the cache manager bean to use for annotation-driven cache management. A default `CacheResolver` will be initialized behind the scenes with this cache manager. For more fine-grained management of the cache resolution, consider setting the `CacheResolver` directly.

      Implementations must explicitly declare `@Bean`, e.g.

           @Configuration
           @EnableCaching
           public class AppConfig extends CachingConfigurerSupport {
               @Bean // important!
               @Override
               public CacheManager cacheManager() {
                   // configure and return CacheManager instance
               }
               // ...
           }

      See @`EnableCaching` for more complete examples.
      Specified by:
        `cacheManager` in interface `CachingConfigurer`

    - #### cacheResolver

          @Nullable
          public CacheResolver cacheResolver()

      Description copied from interface: `CachingConfigurer`
      Return the `CacheResolver` bean to use to resolve regular caches for annotation-driven cache management. This is an alternative and more powerful option of specifying the `CacheManager` to use.

      If both a `CachingConfigurer.cacheManager()` and `#cacheResolver()` are set, the cache manager is ignored.

      Implementations must explicitly declare `@Bean`, e.g.

           @Configuration
           @EnableCaching
           public class AppConfig extends CachingConfigurerSupport {
               @Bean // important!
               @Override
               public CacheResolver cacheResolver() {
                   // configure and return CacheResolver instance
               }
               // ...
           }

      See `EnableCaching` for more complete examples.
      Specified by:
        `cacheResolver` in interface `CachingConfigurer`

    - #### keyGenerator

          @Nullable
          public KeyGenerator keyGenerator()

      Description copied from interface: `CachingConfigurer`
      Return the key generator bean to use for annotation-driven cache management. Implementations must explicitly declare `@Bean`, e.g.

           @Configuration
           @EnableCaching
           public class AppConfig extends CachingConfigurerSupport {
               @Bean // important!
               @Override
               public KeyGenerator keyGenerator() {
                   // configure and return KeyGenerator instance
               }
               // ...
           }

      See @`EnableCaching` for more complete examples.
      Specified by:
        `keyGenerator` in interface `CachingConfigurer`

    - #### errorHandler

          @Nullable
          public CacheErrorHandler errorHandler()

      Description copied from interface: `CachingConfigurer`
      Return the `CacheErrorHandler` to use to handle cache-related errors.

      By default,`SimpleCacheErrorHandler` is used and simply throws the exception back at the client.

      Implementations must explicitly declare `@Bean`, e.g.

           @Configuration
           @EnableCaching
           public class AppConfig extends CachingConfigurerSupport {
               @Bean // important!
               @Override
               public CacheErrorHandler errorHandler() {
                   // configure and return CacheErrorHandler instance
               }
               // ...
           }

      See @`EnableCaching` for more complete examples.
      Specified by:
        `errorHandler` in interface `CachingConfigurer`